<script lang="ts" context="module">
import * as Api from '../../api/Api';

export async function load({page, session}) {
    let auth = await Api.Auth.check(session.sess).then(a => a).catch(() => undefined);
    if (!auth) {
        return {
            status: 302,
            redirect: '/login?to=' + ('/join/' + page.params.id + '-' + page.params.code)
        }
    }
    let state = await Api.State.get(session.sess, auth.sessionInfo.user).then(s => s).catch(() => undefined);
    return {
        props: {
            sess: session.sess,
            state: state,
            meeting: state ? undefined : await Api.Meeting.get(session.sess, page.params.id, page.params.code).then(m => m).catch(() => undefined),
            code: page.params.code
        }
    }
}
</script>
<script lang="ts">
import {formatDate} from '../../util/DateFormat'
import Button from "../../components/Button.svelte";
import { goto } from '$app/navigation';

export let sess: string, state: Api.StateInfo, meeting: Api.MeetingInfo, code: string;

const leave = () => {
    Api.Meeting.leave(sess, state.meetingID).then(() => {
        goto('/');
    }).catch(() => {
        goto('/error?from=meeting-leave');
    });
};

const join = () => {
    Api.Meeting.join(sess, meeting.meetingID, code).then(() => {
        goto('/');
    }).catch(() => {
        goto('/error?from=meeting-join');
    });
};
</script>
<svelte:head>
    <title>Join / Leave Meeting | AZtendance</title>
</svelte:head>
{#if state}
<h2>Leave Meeting</h2>
<p>Meeting ID: {state.meetingID}</p>
<p>Joined: {formatDate(new Date(state.since * 1000))}</p>
<p>Before you leave, make sure to clean up your workspace!</p>
<p>If you're leaving early, be sure to tell a mentor.</p>
<Button content="Leave Meeting" theme="primary" onclick={leave} />
{:else}
<h2>Join Meeting</h2>
<p>Meeting ID: {meeting.meetingID}</p>
<p>Meeting Code: {meeting.meetingCode}</p>
<p>Meeting Location: {meeting.loc}</p>
<Button content="Join Meeting" theme="primary" onclick={join} />
{/if}